import { StateContext, Store } from '@ngxs/store';
import { Node, Entity, NodeEntity } from './file-browser.model';
import { GenerateFileBrowser, GetNode, GenerateTreeLevels, GenerateHistory, ToggleFolder, SortNodes } from './file-browser.actions';
import { NodeSortingService } from '../services/node-sorting.service';
export interface FileBrowserStateModel {
    nodes: Node[];
    entities: Entity[];
    nodeEntity: NodeEntity[];
    currentNode: Node;
    childNodes: Node[];
    currentEntity: Entity;
    childEntities: Entity[];
    nodeSelected: Node;
    history: Entity[];
    sort: String;
}
export declare class FileBrowserState {
    private store;
    private nodeSorting;
    constructor(store: Store, nodeSorting: NodeSortingService);
    static getNodes(state: FileBrowserStateModel): NodeEntity[];
    static getChildEntities(state: FileBrowserStateModel): Entity[];
    static getHistory(state: FileBrowserStateModel): Entity[];
    static getSort(state: FileBrowserStateModel): String;
    static getNodeSelected(state: FileBrowserStateModel): Node;
    generateFileBrowser({patchState}: StateContext<FileBrowserStateModel>, {nodes, entities}: GenerateFileBrowser): void;
    getNode({getState, patchState}: StateContext<FileBrowserStateModel>, {node}: GetNode): void;
    generateHistory({getState, patchState}: StateContext<FileBrowserStateModel>, {node}: GenerateHistory): void;
    generateTreeFirstLevel({getState, patchState}: StateContext<FileBrowserStateModel>): void;
    generateTreeLevels({getState, patchState}: StateContext<FileBrowserStateModel>, {level}: GenerateTreeLevels): void;
    toggleFolder({getState, patchState}: StateContext<FileBrowserStateModel>, {node}: ToggleFolder): void;
    sortNodes({getState, patchState}: StateContext<FileBrowserStateModel>, {sort}: SortNodes): void;
}
